import random


class Shape:
    # shapeall[9][25]
    shapeall = [[
        0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0
    ],
                [
                    0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0,
                    0, 0, 1, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0,
                    0, 0, 0, 0, 0
                ]]

    def __init__(self):
        return

    def getnextsh(self, x, y, il, ic, level):
        no, i = 0, 0
        self.no = random.randint(0, 6 - 1) + level
        self.px = x
        self.py = y
        self.l = il
        self.c = ic
        for i in range(0, 25):
            self.s[i // 5][i % 5] = self.b[i // 5][i % 5]
            self.b[i // 5][i % 5] = Shape.shapeall[self.no][i]
        return 0

    def init(self, x, y, w, il, ic, level):
        self.px = x
        self.py = y
        self.l = il
        self.c = ic
        self.width = w
        self.s = [([0] * 5) for i in range(5)]
        self.b = [([0] * 5) for i in range(5)]
        self.t = [([0] * 5) for i in range(0, 5)]
        self.l, self.c = 0, 0
        self.getnextsh(x, y, il, ic, level)
        return 0

    def rotate(self):
        i, j = 0, 0
        for i in range(0, 5):
            for j in range(0, 5):
                self.t[i][j] = self.s[i][j]

        for i in range(0, 5):
            for j in range(0, 5):
                self.s[i][j] = self.t[4 - j][i]

        return 0

    def paint(self, canvas):
        i, j = 0, 0
        for i in range(0, 5):
            for j in range(0, 5):
                if self.s[i][j]:
                    canvas.drawRect(self.px + j * (self.width // 5) + 1,
                                    self.py + i * (self.width // 5) + 1,
                                    self.width // 5 - 2, self.width // 5 - 2)

        return 0

    def paintnext(self, canvas, x, y):
        i, j = 0, 0
        for i in range(0, 5):
            for j in range(0, 5):
                if self.b[i][j]:
                    canvas.drawRect(x + j * (self.width // 5) + 1,
                                    y + i * (self.width // 5) + 1,
                                    self.width // 5 - 2, self.width // 5 - 2)
        return 0

    def move(self, direct):
        if direct == 1:
            self.px = self.px - self.width // 5
            self.c = self.c - 1
        elif direct == 2:
            self.px = self.px + self.width // 5
            self.c = self.c + 1
        else:
            self.py = self.py + self.width // 5
            self.l = self.l + 1
        return 0
